--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

--------------------------------------------------------------------
--datetime och smalldatetime
--------------------------------------------------------------------

SELECT GETDATE()




-- Enbart tid
SELECT CAST('14:00:00' AS datetime)
SELECT CAST('2:00:00 pm' AS datetime)
SELECT CAST('14:00:00' AS time)
SELECT CAST('14:00:00' AS time(7))
SELECT CAST('14:00:00' AS time(2))
SELECT CAST('14:00:00' AS time(0))

--Numeric Date Format
--r beroende av SET DATEFORMAT och SET LANGUAGE
--Tilltna separatorer r ., -, /
SELECT CAST('02-03-04' AS datetime) --tolkas som mdy
SET DATEFORMAT dmy
EXEC sp_helplanguage
SET LANGUAGE us_english --mdy
SET LANGUAGE french		--dmy
SELECT CAST('1998-02-28' AS datetime)
SELECT CAST('1998-02-28' AS datetime2) --Fr dom nya typerna s r tolkningen alltod ymd


--Alphabetic Date Format
--Ej beroende av SET DATEFORMAT, men av SET LANGUAGE
SELECT CAST('15 November 1998' AS datetime)


--Unseparated String Format, tolkas *alltid* som YYYYMMDD (bra!)
--Ej beroende av SET DATEFORMAT
SELECT CAST('19980228' AS datetime)


-- Bde datum och tid
SELECT CAST('19980523 14:00:00' AS datetime)

SET LANGUAGE french
SELECT CAST('1998-05-23 14:00:00' AS datetime) --Ej sprkneutralt
SELECT CAST('1998-05-23 14:00:00' AS datetime2) --Sprkneutralt
SELECT CAST('1998-05-23' AS datetime2) --Sprkneutralt
SELECT CAST('1998-05-23 14:00:00' AS date) --Sprkneutralt
SET LANGUAGE us_english

--ISO 8601 format (msta ha tidsangivelse)
--Ej beroende av SET DATEFORMAT
SELECT CAST('1998-03-25T14:12:14' AS datetime)


--"Nu"
SELECT GETDATE()			--SQL Server	datetime
SELECT CURRENT_TIMESTAMP	--ANSI SQL		datetime
SELECT SYSDATETIME()		--SQL Server	datetime2(7)
SELECT SYSDATETIMEOFFSET()	--SQL Server	datetimeoffset


--Format fr utmatning bestms av klienten.
--Kan dock konvertera till strng, och styra format. Notera 3:e parametern till CONVERT.
SELECT
 CONVERT(varchar(30), GETDATE(), 103)
,CONVERT(varchar(30), GETDATE(), 104)
,CONVERT(varchar(30), GETDATE(), 105)
,CONVERT(varchar(30), GETDATE(), 121)

--FORMAT kom 2012, drar mer CPU n CONVERT
SELECT FORMAT(GETDATE(), 'yyyy-MM-dd hh:mm:ss')
SELECT FORMAT(GETDATE(), 'yyyyMMddhhmmss')

-------------------------------------------------------------------------------------------------
--Jmfr lptid och CPU i trace
--Tar ca en halv minut
--11 miljoner anrop av FORMAT eller CONVERT
USE AdventureworksDW

--Ramp up, s data r i cache (Buffer Pool, BP)
SELECT MAX(CONVERT(varchar(30), OrderDate, 120)) FROM FactResellerSalesXL 

--Jmfr nedanstende tv
SELECT MAX(CONVERT(varchar(30), OrderDate, 120)) FROM FactResellerSalesXL
SELECT MAX(FORMAT(OrderDate, 'yyyy-MM-dd hh:mm:ss')) FROM FactResellerSalesXL
-------------------------------------------------------------------------------------------------


--Anvndbara functions:
--DATEDIFF()
--DATEADD()
--DATEPART()
--EOMONTH()















--Fr er som r intresserade:

--SWITCHOFFSET
--ndrar offset men behller "vrdet"
SELECT 
 SYSDATETIMEOFFSET()
,SWITCHOFFSET(SYSDATETIMEOFFSET(), '-05:00')
,DATEDIFF(hour, SYSDATETIMEOFFSET(), SWITCHOFFSET(SYSDATETIMEOFFSET(), '-05:00'))


--TODATETIMEOFFSET 
--Gr om datetime2 till datetimeoffset
SELECT
 SYSDATETIME()
,TODATETIMEOFFSET(SYSDATETIME(), '-06:00')

--Oops!
SELECT ISDATE('hej')
SELECT ISDATE('20100223')
SELECT ISDATE('1700-01-01')
SELECT ISDATE('2010-05-17 15:16:39.2897748 -06:00')
SELECT TRY_CAST('1700-01-01' AS datetime2)




SELECT DATEFROMPARTS(2004, 02, 03)

