--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE Adventureworks
GO

-----------------------------------------------------
--lokal temptabell
-----------------------------------------------------

--Skapa temp tabell
CREATE TABLE #Squares
( Number int PRIMARY KEY,
  NumberSquared int
);

--Populera
DECLARE @Counter int = 0;

WHILE @Counter < 1000 BEGIN
  INSERT INTO #Squares (Number, NumberSquared)
    VALUES (@Counter, @Counter * @Counter);
  SET @Counter += 1;
END;

SELECT * FROM #Squares;
--Prova frn annan session


--Disconnect och anslut igen, och prova igen
USE tempdb;

SELECT * FROM #Squares;
GO

-----------------------------------------------------
--Global temptabell
-----------------------------------------------------

CREATE TABLE ##Squares
( Number int PRIMARY KEY,
  NumberSquared int
);

DECLARE @Counter int = 0;
WHILE @Counter < 1000 BEGIN
  INSERT ##Squares (Number, NumberSquared)
    VALUES (@Counter, @Counter * @Counter);
  SET @Counter += 1;
END;

SELECT * FROM ##Squares;

--Prova frn annan session
SELECT * FROM ##Squares;
GO

-----------------------------------------------------
--SELECT INTO
-----------------------------------------------------

--Till temptabell
SELECT p.Name, p.ProductNumber
INTO #minaProdukter
FROM Production.Product AS p

SELECT * FROM #minaProdukter

--Till permanent tabell
SELECT p.Name, p.ProductNumber
INTO dbo.gurka
FROM Adventureworks.Production.Product AS p

SELECT * FROM dbo.gurka


-----------------------------------------------------
--Tabell variabel
-----------------------------------------------------
DECLARE @Squares table
	( Number int PRIMARY KEY,
	  NumberSquared int
	);

DECLARE @Counter int = 0;
WHILE @Counter < 1000 BEGIN
  INSERT @Squares (Number, NumberSquared)
    VALUES (@Counter, @Counter * @Counter);
  SET @Counter += 1;
END;

SELECT * FROM @Squares;
GO

--Vad r bttre, tabellvariabel eller temptabell?
--Testa fr ett enskilt fall. Som schablon s sger jag temptabell (br med sig statistik och "cardinality", tabellvariabler br bara med sig kardinalitet (i 2019))).




--Eller CTE/Derived table?
--eller memory-optimized tabell? (Enterprise Edition innan 2016)

