--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE Adventureworks

SELECT * FROM Person.Person

--Selektivitet
SELECT TOP(5) FirstName, COUNT(*) AS antal
FROM Person.Person
GROUP BY FirstName
ORDER BY antal DESC

SELECT TOP(5) LastName, COUNT(*) AS antal
FROM Person.Person
GROUP BY LastName
ORDER BY antal DESC

--Antal rader i tabellen
SELECT COUNT(*) FROM Person.Person

--Vi vill hitta alla Richard Diaz (1 rad)
--103 som heter Richard
--211 som heter Diaz

EXEC sp_indexinfo 'Person'

--Disabla existerande index p LastName, FirstName, MiddleName
ALTER INDEX IX_Person_LastName_FirstName_MiddleName ON Person.Person DISABLE

--Index p bara efternamn
CREATE INDEX ix_nameSearch ON Person.Person(LastName) --WITH DROP_EXISTING

SET STATISTICS IO ON

--Kostnad?
SELECT * FROM Person.Person WHERE FirstName = 'Richard' AND LastName = 'Diaz'
SELECT * FROM Person.Person WHERE LastName = 'Diaz'
SELECT * FROM Person.Person WHERE FirstName = 'Richard'

--Index p bara frnamn
CREATE INDEX ix_nameSearch ON Person.Person(FirstName) WITH DROP_EXISTING

--Index p bara efternamn, frnamn
CREATE INDEX ix_nameSearch ON Person.Person(LastName, FirstName) WITH DROP_EXISTING

--r (LastName, FirstName) samma sak som (FirstName, LastName)?

--Tv index
CREATE INDEX ix_nameSearch ON Person.Person(FirstName) WITH DROP_EXISTING
CREATE INDEX ix_nameSearch2 ON Person.Person(LastName) --WITH DROP_EXISTING

EXEC sp_indexinfo 'Person'







--terstll
DROP INDEX ix_nameSearch ON Person.Person
DROP INDEX ix_nameSearch2 ON Person.Person
GO
ALTER INDEX IX_Person_LastName_FirstName_MiddleName ON Person.PErson REBUILD




