--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE Adventureworks

---------------------------------------------------------------------------------------------------------------------------
--Vi hade detta sen tidigare

--Icke-klustrat index fr att understda nedan:
CREATE INDEX x ON Person.Person(title)
 WITH DROP_EXISTING

SET STATISTICS IO ON

SELECT * FROM Person.Person WHERE Title = 'Sr.'					--   11 rader
SELECT * FROM Person.Person WHERE Title = 'Ms.'					--  415 rader
SELECT * FROM Person.Person WHERE Title = 'Mr.'					--  577 rader
SELECT * FROM Person.Person WHERE Title IS NULL 				--18963 rader
SELECT * FROM Person.Person WITH(INDEX(x)) WHERE Title IS NULL	--18963 rader

--Inge vidare prestanda med lgre selektivitet
-------------------------------------------------------------------------------------------------

--D ska vi se om det blir bttre att tcka frgan

--Disabla existerande index p LastName, FirstName, MiddleName
ALTER INDEX IX_Person_LastName_FirstName_MiddleName ON Person.Person DISABLE

--------------------------------------------------------------------------------------------------
--Begrnsa frgan till bara de kolumner som behvs
SELECT p.BusinessEntityID, p.FirstName, p.LastName FROM Person.Person AS p WHERE Title = 'Sr.'
SELECT p.BusinessEntityID, p.FirstName, p.LastName FROM Person.Person AS p WHERE Title = 'Ms.'
SELECT p.BusinessEntityID, p.FirstName, p.LastName FROM Person.Person AS p WHERE Title IS NULL 

--Inkludera klumnerna fr ovan i indexnyckeln
CREATE INDEX x ON Person.Person(title, FirstName, LastName, BusinessEntityID)
 WITH DROP_EXISTING

---------------------------------------------------------------------------------------------------------------------------
--Eller som inkluderade kolumner
CREATE INDEX x ON Person.Person(title)
 INCLUDE(FirstName, LastName, BusinessEntityID)
 WITH DROP_EXISTING

--Men, det rcker att ta med en till kolumn s tcker indexet inte lngre...
SELECT p.BusinessEntityID, p.FirstName, p.LastName, p.MiddleName 
FROM Person.Person AS p WHERE Title = 'Mr.'
--------------------------------------------------------------------------------------------------

--terstll
DROP INDEX x ON Person.Person
ALTER INDEX IX_Person_LastName_FirstName_MiddleName ON Person.PErson REBUILD

