--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE tempdb;
GO

CREATE SCHEMA PetStore
GO

--Tabell med computed column
CREATE TABLE PetStore.Pet
(PetID int IDENTITY(1,1) PRIMARY KEY,
 PetName nvarchar(30) NOT NULL,
 PetType nvarchar(10) NOT NULL,
 DateOfBirth date NOT NULL,
 YearOfBirth AS DATEPART(year,DateOfBirth) --PERSISTED
)
GO

INSERT PetStore.Pet (PetName, PetType, DateOfBirth)
VALUES ('Brutus','DOG','2007-12-31'),
       ('Bruno','DOG','2006-01-01'),
       ('Tweetie','BIRD','2005-04-02');


SELECT * FROM PetStore.Pet;

DROP TABLE PetStore.Pet
