--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE tempdb
GO

CREATE SCHEMA PetStore
GO

CREATE TABLE PetStore.Owner
( OwnerID int IDENTITY(1,1) PRIMARY KEY,
  OwnerName nvarchar(30) NOT NULL,
  HairColor nvarchar(10) NULL
)

INSERT INTO PetStore.Owner (OwnerName, HairColor)
VALUES('Kalle', 'Bald')

INSERT INTO PetStore.Owner (OwnerName, HairColor)
VALUES('Eva', 'Red')

SELECT * FROM PetStore.Owner

--Lgg till kolumn
ALTER TABLE PetStore.Owner
  ADD PreferredName nvarchar(30) NULL;
GO

--Om man vill ha NOT NULL fr nya kolumnen s mste den ha default
--ALTER TABLE PetStore.Owner
--  ADD PreferredName nvarchar(30) NOT NULL DEFAULT 'Hej';
--GO

SELECT * FROM PetStore.Owner;
GO

UPDATE PetStore.Owner SET PreferredName = 'TheBoss'
WHERE OwnerID = 1

SELECT * FROM PetStore.Owner;

UPDATE PetStore.Owner SET PreferredName = 'The Fantastic Super Duper maginigficant Boss'
WHERE OwnerID = 1


--ndra datatyp
ALTER TABLE PetStore.Owner
  ALTER COLUMN PreferredName nvarchar(60)



--ndra nullbarhet
ALTER TABLE PetStore.Owner
  ALTER COLUMN PreferredName nvarchar(60) NOT NULL


--Se upp fr "Design Table" i SSMS!!!

--Ta bort kolumn
ALTER TABLE PetStore.Owner
  DROP COLUMN PreferredName;
GO

SELECT * FROM PetStore.Owner;

DROP TABLE PetStore.Owner
