--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE master
GO

SELECT * FROM Adventureworks.Production.Product

SELECT * FROM Production.Product

USE Adventureworks
GO

SELECT * FROM Production.Product
GO

SELECT * FROM Product
SELECT * FROM ErrorLog
SELECT * FROM dbo.ErrorLog
GO

CREATE SCHEMA Reporting --AUTHORIZATION dbo
GO

--Skapa schema med objekt i
CREATE SCHEMA Operations
  CREATE TABLE Flights (FlightID int IDENTITY(1,1) PRIMARY KEY,
                        Origin nvarchar(3),
                        Destination nvarchar(3))
GO

--Verifiera med Object Explorer...
SELECT * FROM Operations.Flights

DROP TABLE Operations.Flights
GO
DROP SCHEMA Operations
GO

--Samma syntax, men exekvera delarna separat!!!
CREATE SCHEMA Operations AUTHORIZATION dbo
CREATE TABLE Flights (FlightID int IDENTITY(1,1) PRIMARY KEY,
                      Origin nvarchar(3),
                      Destination nvarchar(3))
GO

--Verifiera med Object Explorer...
DROP TABLE dbo.Flights
GO
DROP TABLE Operations.Flights
GO
DROP SCHEMA Operations
GO

--Gr s hr
CREATE SCHEMA Operations 
CREATE TABLE Operations.Flights (FlightID int IDENTITY(1,1) PRIMARY KEY,
                      Origin nvarchar(3),
                      Destination nvarchar(3))

--Rttighetstilldelning p schemaniv
GRANT SELECT ON SCHEMA::Operations TO Kalle

SELECT * FROM Operations.Flights


--Byta schema:
ALTER SCHEMA Sales TRANSFER dbo.mytable

--Stta gare
CREATE SCHEMA mySchema AUTHORIZATION dbo


CREATE USER Kalle WITHOUT LOGIN
