--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE Adventureworks

DBCC DROPCLEANBUFFERS --Tm data cachen, eventuellt CHECKPOINT fre
DBCC FREEPROCCACHE --Tm plancachen
DBCC FLUSHPROCINDB(4) --Tm plancachen fr viss databas

--Exakt text matcning
SELECT OrderQty, SUM(UnitPrice)
FROM Sales.SalesOrderDetail
WHERE UnitPriceDiscount = 0.05
GROUP BY OrderQty

SELECT OrderQty, SUM(UnitPrice)
FROM Sales.SalesOrderDetail
WHERE UnitPriceDiscount = 0.05
GROUP BY OrderQty

SELECT OrderQty, SUM(UnitPrice)
FROM Sales.SalesOrderDetail
WHERE UnitPriceDiscount = 0.00
GROUP BY OrderQty

--Tm plancachen
DBCC FREEPROCCACHE

--Hur ser det ut i plan cachen?
SELECT * FROM sys.syscacheobjects ORDER BY objtype

SELECT objtype, COUNT(*) AS antal, SUM((pagesused*8192)/(1024)) minneKB
FROM sys.syscacheobjects
GROUP BY objtype

SELECT objtype, COUNT(*) AS antal, SUM((pagesused*8192)/(1024)) minneKB
FROM sys.syscacheobjects
WHERE usecounts = 1
GROUP BY objtype

--Cacha inte planer som bara krs en gng
EXEC sp_configure 'optimize for ad hoc workloads', 1 RECONFIGURE
EXEC sp_configure 'optimize for ad hoc workloads', 0 RECONFIGURE

DBCC FREEPROCCACHE --Tm plancachen

SELECT *
FROM Sales.SalesOrderHeader
WHERE SalesOrderID = 34567

SELECT *
FROM Sales.SalesOrderHeader
WHERE SalesOrderID = 34369

SELECT * FROM sys.syscacheobjects ORDER BY objtype

--Tvinga autoparameterisering
ALTER DATABASE Adventureworks2014 SET PARAMETERIZATION FORCED
ALTER DATABASE Adventureworks2014 SET PARAMETERIZATION SIMPLE


--Parameterisering frn app:
sp_executesql...
sp_prepare...

exec sp_executesql N'SELECT ''Server[@Name='' + quotename(CAST(          serverproperty(N''Servername'')         AS sysname),'''''''') + '']'' + ''/Database[@Name='' + quotename(db_name(),'''''''') + '']'' + ''/Table[@Name='' + quotename(tbl.name,'''''''') + '' and @Schema='' + quotename(SCHEMA_NAME(tbl.schema_id),'''''''') + '']'' + ''/Column[@Name='' + quotename(clmns.name,'''''''') + '']'' AS [Urn], clmns.name AS [Name], clmns.column_id AS [ID], clmns.is_nullable AS [Nullable], clmns.is_computed AS [Computed], CAST(ISNULL(cik.index_column_id, 0) AS bit) AS [InPrimaryKey], clmns.is_ansi_padded AS [AnsiPaddingStatus], CAST(clmns.is_rowguidcol AS bit) AS [RowGuidCol], ISNULL(cc.definition,N'''') AS [ComputedText], CAST(ISNULL(cc.is_persisted, 0) AS bit) AS [IsPersisted], ISNULL(clmns.collation_name, N'''') AS [Collation], CAST(ISNULL((select TOP 1 1 from sys.foreign_key_columns AS colfk where colfk.parent_column_id = clmns.column_id and colfk.parent_object_id = clmns.object_id), 0) AS bit) AS [IsForeignKey], clmns.is_identity AS [Identity], CAST(ISNULL(ic.seed_value,0) AS bigint) AS [IdentitySeed], CAST(ISNULL(ic.increment_value,0) AS bigint) AS [IdentityIncrement], CAST(ISNULL(ic.seed_value,0) AS numeric(38)) AS [IdentitySeedAsDecimal], CAST(ISNULL(ic.increment_value,0) AS numeric(38)) AS [IdentityIncrementAsDecimal], (case when clmns.default_object_id = 0 then N'''' when d.parent_object_id > 0 then N'''' else d.name end) AS [Default], (case when clmns.default_object_id = 0 then N'''' when d.parent_object_id > 0 then N'''' else schema_name(d.schema_id) end) AS [DefaultSchema], ISNULL(dc.Name, N'''') AS [DefaultConstraintName], (case when clmns.rule_object_id = 0 then N'''' else r.name end) AS [Rule], (case when clmns.rule_object_id = 0 then N'''' else schema_name(r.schema_id) end) AS [RuleSchema], CAST(ISNULL(COLUMNPROPERTY(clmns.object_id, clmns.name, N''IsDeterministic''),0) AS bit) AS [IsDeterministic], CAST(ISNULL(COLUMNPROPERTY(clmns.object_id, clmns.name, N''IsPrecise''),0) AS bit) AS [IsPrecise], ISNULL(ic.is_not_for_replication, 0) AS [NotForReplication], CAST(COLUMNPROPERTY(clmns.object_id, clmns.name, N''IsFulltextIndexed'') AS bit) AS [IsFullTextIndexed], CAST(COLUMNPROPERTY(clmns.object_id, clmns.name, N''StatisticalSemantics'') AS int) AS [StatisticalSemantics], CAST(clmns.encryption_type AS int) AS [EncryptionType], clmns.encryption_algorithm_name AS [EncryptionAlgorithm], clmns.column_encryption_key_id AS [ColumnEncryptionKeyID], ceks.name AS [ColumnEncryptionKeyName], CAST(clmns.is_filestream AS bit) AS [IsFileStream], CAST(clmns.is_sparse AS bit) AS [IsSparse], CAST(clmns.is_column_set AS bit) AS [IsColumnSet], usrt.name AS [DataType], s1clmns.name AS [DataTypeSchema], ISNULL(baset.name, N'''') AS [SystemType], CAST(CASE WHEN baset.name IN (N''nchar'', N''nvarchar'') AND clmns.max_length <> -1 THEN clmns.max_length/2 ELSE clmns.max_length END AS int) AS [Length], CAST(clmns.precision AS int) AS [NumericPrecision], CAST(clmns.scale AS int) AS [NumericScale], ISNULL(xscclmns.name, N'''') AS [XmlSchemaNamespace], ISNULL(s2clmns.name, N'''') AS [XmlSchemaNamespaceSchema], ISNULL( (case clmns.is_xml_document when 1 then 2 else 1 end), 0) AS [XmlDocumentConstraint], CASE WHEN usrt.is_table_type = 1 THEN N''structured'' ELSE N'''' END AS [UserType], clmns.generated_always_type AS [GeneratedAlwaysType], CAST(clmns.is_hidden AS bit) AS [IsHidden], CAST(clmns.is_masked AS bit) AS [IsMasked], ISNULL((SELECT ms.masking_function FROM sys.masked_columns ms WHERE ms.object_id = clmns.object_id AND ms.column_id = clmns.column_id), N'''') AS [MaskingFunction], CAST(          CASE          WHEN [sc].[label] IS NOT NULL or [sc].[label_id] IS NOT NULL or [sc].[information_type] IS NOT NULL or [sc].[information_type_id] IS NOT NULL or [sc].[rank] IS NOT NULL THEN 1          ELSE 0          END         AS bit) AS [IsClassified], ISNULL([sc].[label], N'''') AS [SensitivityLabelName], ISNULL([sc].[label_id], N'''') AS [SensitivityLabelId], ISNULL([sc].[information_type], N'''') AS [SensitivityInformationTypeName], ISNULL([sc].[information_type_id], N'''') AS [SensitivityInformationTypeId], ISNULL([sc].[rank], -1) AS [SensitivityRank], ISNULL(clmns.graph_type, 0) AS [GraphType] FROM sys.tables AS tbl INNER JOIN sys.all_columns AS clmns ON clmns.object_id=tbl.object_id LEFT OUTER JOIN sys.indexes AS ik ON ik.object_id = clmns.object_id and 1=ik.is_primary_key LEFT OUTER JOIN sys.index_columns AS cik ON cik.index_id = ik.index_id and cik.column_id = clmns.column_id and cik.object_id = clmns.object_id and 0 = cik.is_included_column LEFT OUTER JOIN sys.computed_columns AS cc ON cc.object_id = clmns.object_id and cc.column_id = clmns.column_id LEFT OUTER JOIN sys.identity_columns AS ic ON ic.object_id = clmns.object_id and ic.column_id = clmns.column_id LEFT OUTER JOIN sys.objects AS d ON d.object_id = clmns.default_object_id LEFT OUTER JOIN sys.default_constraints as dc ON clmns.default_object_id = dc.object_id LEFT OUTER JOIN sys.objects AS r ON r.object_id = clmns.rule_object_id LEFT OUTER JOIN sys.column_encryption_keys AS ceks ON (ceks.column_encryption_key_id = clmns.column_encryption_key_id) LEFT OUTER JOIN sys.types AS usrt ON usrt.user_type_id = clmns.user_type_id LEFT OUTER JOIN sys.schemas AS s1clmns ON s1clmns.schema_id = usrt.schema_id LEFT OUTER JOIN sys.types AS baset ON (baset.user_type_id = clmns.system_type_id and baset.user_type_id = baset.system_type_id) or ((baset.system_type_id = clmns.system_type_id) and (baset.user_type_id = clmns.user_type_id) and (baset.is_user_defined = 0) and (baset.is_assembly_type = 1))  LEFT OUTER JOIN sys.xml_schema_collections AS xscclmns ON xscclmns.xml_collection_id = clmns.xml_collection_id LEFT OUTER JOIN sys.schemas AS s2clmns ON s2clmns.schema_id = xscclmns.schema_id LEFT OUTER JOIN sys.sensitivity_classifications AS sc ON sc.major_id = clmns.object_id and sc.minor_id = clmns.column_id WHERE (clmns.name=@_msparam_0)and((tbl.name=@_msparam_1 and SCHEMA_NAME(tbl.schema_id)=@_msparam_2))',N'@_msparam_0 nvarchar(4000),@_msparam_1 nvarchar(4000),@_msparam_2 nvarchar(4000)'
,@_msparam_0=N'CurrencyAlternateKey',@_msparam_1=N'DimCurrency',@_msparam_2=N'dbo'

--Men ingenting slr stored procedures!