--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE Adventureworks
GO

DROP PROC IF EXISTS p
DROP PROC IF EXISTS p2
GO

CREATE PROC p AS 
SELECT * FROM dbo.myDummyTable
GO

CREATE PROC p2 AS 
EXEC p
GO


EXEC p

CREATE TABLE dbo.myDummyTable(c1 int)

EXEC p2

--"Statisk"
EXEC sp_depends 'p'

--"Dynamiska"
SELECT * FROM sys.dm_sql_referenced_entities('dbo.p', 'OBJECT')
SELECT * FROM sys.dm_sql_referenced_entities('dbo.p2', 'OBJECT')

SELECT * FROM sys.dm_sql_referencing_entities('dbo.p', 'OBJECT')
SELECT * FROM sys.dm_sql_referencing_entities('dbo.myDummyTable', 'OBJECT')

