--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

DROP LOGIN Kalle
DROP USER kalle
GO

CREATE LOGIN Kalle WITH PASSWORD = 'losen'
USE Adventureworks;
CREATE USER Kalle
GO

CREATE TABLE t(c1 int)
GO

CREATE PROC dbo.DisplayExecutionContext
AS
SELECT * FROM t
SELECT USER_NAME(), SUSER_SNAME(), ORIGINAL_LOGIN()
GO


EXEC dbo.DisplayExecutionContext;

--ppna ett annat fnster och logga p som Kalle
-------------------------------------------------------------------------------------
EXEC dbo.DisplayExecutionContext;
-------------------------------------------------------------------------------------


GRANT EXECUTE ON dbo.DisplayExecutionContext TO Kalle
GO

--Frsk igen, annat fnster
-------------------------------------------------------------------------------------
EXEC dbo.DisplayExecutionContext;
GO
-------------------------------------------------------------------------------------

ALTER PROC dbo.DisplayExecutionContext
AS
DECLARE @sql varchar(500)
SET @sql = 'SELECT * FROM t'
EXEC(@sql)
SELECT USER_NAME(), SUSER_SNAME(), ORIGINAL_LOGIN()
GO



ALTER PROC dbo.DisplayExecutionContext
WITH EXECUTE AS 'dbo'
AS
DECLARE @sql varchar(500)
SET @sql = 'SELECT * FROM t'
EXEC(@sql)
SELECT USER_NAME(), SUSER_SNAME(), ORIGINAL_LOGIN()
GO

--Frsk igen, annat fnster
-------------------------------------------------------------------------------------
EXEC dbo.DisplayExecutionContext;
GO
-------------------------------------------------------------------------------------

--Stda
DROP PROC dbo.DisplayExecutionContext;


-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
--EXECUTE AS som kommando
EXECUTE AS LOGIN = 'Kalle'
EXECUTE AS USER = 'Kalle'

REVERT

--Alternativ till EXECUTE AS:
-- https://www.sommarskog.se/grantperm.html